/* gno3dtet: 3D Tetris game for GNOME
 * Copyright (C) 1999, 2000, 2001 Sebastien Nicoud <seb@eseb.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
*/

#ifndef _CSETTINGS
#define _CSETTINGS

#include "common.h"

class CSettings
{
// typedefs, consts
public:
	enum { // diff from the easiest to the hardest
		diff_EASIEST_EXCLUDED,
		diff_EASY,
		diff_MEDIUM,
		diff_HARD,
		diff_HARDEST_EXCLUDED
	};
	static const gchar *diff_descriptors[5];
	static const gchar *str_width;
	static const gchar *str_height;
	static const gchar *str_depth;
	static const gchar *str_diff;
	enum { // speed from slowest to the fastest
		speed_SLOWEST_EXCLUDED,
		speed_NORMAL,
		speed_FAST,
		speed_INSTANT,
		speed_FASTEST_EXCLUDED
	};
	static const gchar *speed_descriptors[5];

// attributes
public:
	gint	 _w;
	gint	 _h;
	gint	 _d;
	gint	 _total_cubes;
	gint	 _difficulty;
	guint    _keys[16];
	gint	 _speed;
	gboolean _show_np;
	gboolean _show_scale;	
	gboolean _show_score;
	gboolean _show_stats;
	gboolean _sound_support;
	gboolean _pause_on_nofocus;
	gboolean _resume_on_focus;
	gint	 _nhofl; // nb lines in HOF
	gboolean _show_old_score;
	
// contructor
public:
	CSettings(); // constructeur par defaut
	CSettings(const CSettings &ind); // constructeur de copy
	
// destructor
	~CSettings();

// operators
public:
	CSettings &operator= (const CSettings &ind); // affectation de recopie
	friend ostream &operator<< (ostream &os, CSettings &ind); // output stream

// methods
public:
	gint compute_total_cubes(void) { _total_cubes = _w*_h*_d; return _total_cubes; };
};

#endif
