/* gno3dtet: 3D Tetris game for GNOME
 * Copyright (C) 1999, 2000, 2001 Sebastien Nicoud <seb@eseb.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
*/

#ifndef _CSOUND
#define _CSOUND

#include "common.h"

#define	NUMBER_SOUND_EVENT	11
#define MAX_EVENT_LEN	40
#define MAX_NOTE_LEN	80

class CSound
{
// constants
public:
	enum {
		snd_SCORE,
		snd_DANGER,
		snd_FALL,
		snd_HOF,
		snd_LAND,
		snd_SCREWD,
		snd_MOVE,
		snd_LEVEL,
		snd_NEW,
		snd_LAYER,
		snd_PAUSE,
		snd_EOL // unused
	};
	
// attributes
public:
	gboolean _played;
	gchar	 _event[MAX_EVENT_LEN];
	gchar	 _note[MAX_NOTE_LEN];
	gchar	 _file[MAX_FILENAME_LENGTH];
	gboolean _valid;
	gchar	 _default[MAX_FILENAME_LENGTH];

// contructor
public:
	CSound(); // constructeur par defaut
	CSound(const CSound &ind); // constructeur de copy
	
// destructor
public:
	~CSound();

// operators
public:
	friend ostream &operator<< (ostream &os, CSound &ind); // output stream

// methods
public:
	gint init(gchar *event, gchar *note, gchar *def);
	gint restore_default(void);
	void save(gboolean synchronize = FALSE);
};

gint csound_get_event_number(gchar *event);
void csound_init_sounds(void);
void csound_play_for_event(gint snd_event, gint snd_event_otherwise = -1);

#endif // _CSOUND
