exception Error

type value =
  | Integer of int
  | Flonum of float
  | String of string
  | Symbol of string
  | True
  | False
  | Unspecified

type variable

type pathname = 
  | Absolute of string                (* absolute path *)
  | ExecRelative of string            (* relative to executable *)
  | EnvRelative of string * string    (* relative to environment variable *)

val set : variable -> value -> unit
val get : variable -> value
val create : value -> value -> variable
val showInterest : variable -> value Chatterbox.interested
val withValue : 
    variable -> (value -> unit) -> unit
val make_textVariable : variable -> Textvariable.textVariable
val write : value -> string
val display : value -> string
val toAbsolute : pathname -> string
val dump : variable -> unit
val boot : pathname list -> (string -> unit) -> unit

val intern : string -> value
val eq : value -> value -> bool
val withBool : value -> (bool -> 'a) -> 'a
val withString : value -> (string -> 'a) -> 'a
val withInteger : value -> (int -> 'a) -> 'a
